package com.hzs.system.sys.service;

import java.util.List;

import com.hzs.common.domain.system.sys.SysDept;
import com.hzs.system.sys.param.SysDeptQueryParam;
import com.hzs.system.sys.vo.SysDeptQueryVO;
import org.apache.ibatis.annotations.Param;

/**
 * 部门管理 服务层
 *
 * @author hzs
 */
public interface ISysDeptService {

    /**
     * 查询部门管理数据
     *
     * @param param
     * @return
     */
    List<SysDeptQueryVO> selectDeptList(SysDeptQueryParam param);

    /**
     * 根据部门ID查询信息
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    SysDept selectDeptById(Long deptId);

    /**
     * 查询部门是否存在用户
     *
     * @param deptId 部门ID
     * @return 结果 true 存在 false 不存在
     */
    boolean checkDeptExistUser(Long deptId);

    /**
     * 校验部门名称是否唯一
     *
     * @param dept 部门信息
     * @return 结果
     */
    String checkDeptNameUnique(SysDept dept);

    /**
     * 新增保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    int insertDept(SysDept dept);

    /**
     * 修改保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    int updateDept(SysDept dept);

    /**
     * 删除部门管理信息
     *
     * @param deptId 部门ID
     * @param userId
     * @return
     */
    int deleteDeptById(Long deptId, Long userId);

    /**
     * 查询重复部门
     *
     * @param userIdList
     * @return
     */
    List<Long> queryRepeatDept(List<Long> userIdList);

}
